#ifndef _HBNET
#define _HBNET

//#define HBNET_WINDOWS
#define HBNET_LINUX 

#ifdef HBNET_LINUX
#include <sys/types.h> 
#include <netinet/in.h> 
#include <netdb.h> 
#include <sys/socket.h> 
#include <sys/wait.h> 
#include <sys/select.h>
//  added after conversion to cpp:
#include <string.h>
#include <arpa/inet.h>
#include <sys/time.h> 
#include <unistd.h>
typedef in_addr_t hbhost;

#elif defined HBNET_WINDOWS  
#include <winsock.h>
typedef int socklen_t;
typedef u_long hbhost;
void gettimeofday(struct timeval* p, void* tz /* IGNORED */);
#endif

#include <stdio.h>

const int APP_MSG_SIZE = 444;

/*  
 *  hbnet packages have 24 bytes to play with
 *  bytes 1-4 = type: mesg | ack | heartbeat
 *  bytes 5-8 = seqno
*/

struct HBaddr
{
    HBaddr(void);
    HBaddr(char*, int);
    HBaddr(struct sockaddr_in);
    bool   operator==(HBaddr&);
    char*  toString(char*);
    hbhost host;
    int    port;
};

int            hbNetOpen(int, int ((*stranded)(struct HBaddr)), char*);
void           takeAim(struct HBaddr); //
void           takeDotAim(char *, int);
int            hbNetUpdate(struct HBaddr*, void*);
void           hbNetClose(void);
int            hbSend(char*, int, int);
int            hbSendTo(struct HBaddr, char*, int, int); //  sets persistent target
char*          hbhostToDot(hbhost, char*);
long           tvSubtraction(timeval, timeval);
#endif
